" Vim syntax file
" Language:    Ksi
" Maintainer:  Michal Moskal <malekith@pld-linux.org>
" Last Change: Jun 23, 2002
" Version:     1.00

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

syn keyword ksiType float int uint void func_ptr ptr union enum struct bool

syn keyword ksiType extern local public version define

syn keyword ksiTerm func global structdef uniondef enumdef

syn keyword ksiTerm abs addr bind bit_and bit_andtc bit_ior bit_not bit_xor block call
syn keyword ksiTerm ceil_div ceil_mod component compound cond const convert elipsis
syn keyword ksiTerm eq exact_div exit exit_loop fcall ffs field fix float_expr
syn keyword ksiTerm floor_div floor_mod ge goto gt indirect input_file label
syn keyword ksiTerm le loop lrotate lshift lt max min minus modify mult ne negate nil
syn keyword ksiTerm non_lvalue nop ordered parm plus rdiv ref result return round_div
syn keyword ksiTerm round_mod rrotate rshift static_var trunc_div trunc_mod
syn keyword ksiTerm truth_and truth_andif truth_not truth_or truth_orif truth_xor uneq
syn keyword ksiTerm unge ungt unit unle unlt unordered var wfl
syn keyword ksiTerm builtin fbuiltin ptr_call ptr_fcall func_ref


syn match	ksiSpec	"[\]\[]"
syn match	ksiNumber "0[xX][0-9a-fA-F]\+"
syn match	ksiNumber "[0-9]\+\((\.[0-9]*)\)\?\([eE]\([+-]\)\?[0-9]*\)\?"

syn match	ksiMacro	"[.\^][a-zA-Z_$@][a-zA-Z_@$0-9]*"

syn match	ksiIdentifier	"[a-zA-Z_$@][a-zA-Z_@$0-9]*"

" Comments
syn keyword ksiTodo	contained	XXX TODO
syn cluster ksiCommentGroup	contains=ksiTodo
syn match ksiComment	"//.*$"	contains=@ksiCommentGroup
syn match ksiComment	"#.*$"	contains=@ksiCommentGroup

syn match	ksiSpecial	display contained "\\\(x\x\x\|.\|$\)"
syn region	ksiString	start=+L\="+ skip=+\\\\\|\\"+ end=+"+ contains=ksiSpecial

" synchronization
syn sync lines=100

" Define the default highlighting.
" For version 5.7 and earlier: only when not done already
" For version 5.8 and later: only when an item doesn't have highlighting yet
if version >= 508 || !exists("did_ksi_syntax_inits")
  if version < 508
    let did_lisp_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

  HiLink ksiIdentifier	Identifier
  HiLink ksiComment	Comment
  HiLink ksiTerm	Statement
  HiLink ksiString	String
  HiLink ksiType	Type
  HiLink ksiMacro	Macro
  HiLink ksiSpec	Special
  HiLink ksiNumber	Number

" HiLink	ksiErrInParen	Error
" HiLink	ksiErrInBracket	Error
  delcommand HiLink
endif

let b:current_syntax = "ksi"

" vim: nowrap
